/*
* Copyright (C) 2010 Daniele E. Domenichelli <daniele.domenichelli@gmail.com>
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef DBUSTUBEDIALOG_H
#define DBUSTUBEDIALOG_H

#include <QDialog>
#include "ui_exampledialog.h"
#include <QDBusConnection>

#include "example.h"
#include "exampleinterface.h"

class KJob;

namespace Test {

class P2PDBusTubeDialog : public QDialog, public Test::Ui::P2PDBusTubeHandler
{
public:
    P2PDBusTubeDialog(QObject* parent);
    virtual ~P2PDBusTubeDialog();

private Q_SLOTS:
//        void onDBusTubeAccepted(PendingOperation* op);
        void onTimerTimeout();
        void handleResult(KJob* job);
//        void onAcceptButtonClicked();

        bool registerExample();
        void useExample();

        void pingExample();
        void onPongExample();

    private:
        QDBusConnection m_dbusConnection;

        Example* m_example;
        OrgFreedesktopTelepathyQt4ExampleInterface* m_exampleClient;

        void syncCall(KJob* job);
        void asyncCall(KJob* job);

};

} // end namespace Test

#endif // DBUSTUBEDIALOG_H
